﻿package 
{
	import fl.controls.Button;
	import fl.controls.ComboBox;
	import fl.controls.Label;
	import fl.controls.TextInput;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.geom.Point;
	
	/**
	 * ...
	 * @author ...
	 */
	public class Main extends Sprite 
	{
		
		static internal var diskList:Array;
		private var solver:SlidingBlock;
		static internal var N:uint;
		
		static internal var ePoint:Point;
		
		private var btn2:Button;
		
		public function Main():void 
		{
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		private function init(e:Event = null):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);
			// entry point
			
			setControls();
			Node.D = N = 3;
			initDisk();
		}
		
		private function initDisk():void {
			
			Disk.size = 500 / N;
			diskList = new Array();
			var k:uint = 1;
			for (var i:uint = 0; i < N; i++ ) {
				diskList.push(new Array);
				for (var j:uint = 0; j < N; j++ ) {
					if (i == N - 1 && j == N - 1) {
						diskList[i].push(new Disk(0, i, j));
						addChild(diskList[i][j]);
						break;
					}
					
					diskList[i].push(new Disk(k++, i, j));
					addChild(diskList[i][j]);
				}
			}
			
			diskList[N - 1][N - 2].buttonMode = true;
			diskList[N - 1][N - 2].addEventListener(MouseEvent.CLICK, diskList[N - 1][N - 2].onClick);
			diskList[N - 2][N - 1].buttonMode = true;
			diskList[N - 2][N - 1].addEventListener(MouseEvent.CLICK, diskList[N - 2][N - 1].onClick);
				
			ePoint = new Point(N - 1, N - 1);
//			btn2.enabled = false;
			
		}

		private function onSet(event:MouseEvent):void {
			setDiskRandom(128);
			
//			btn2.enabled = true;
		}
		
		private function onSolve(event:MouseEvent):void {
			Disk.tweenDelay = 0;
			solver = new SlidingBlock();
//			btn2.enabled = false;
		}

		
		static internal function setDiskRandom(n:uint):void {

			Disk.tweenDelay = 0;
			for (var i:uint = 0; i < n; ) {
				i += Disk.operate((Math.random() < 0.5 ? (Math.random() < 0.5 ? "d" : "u") : (Math.random() < 0.5 ? "r" : "l")), false);
			}
			
			for each(var v:Array in Main.diskList)
				for each(var w:Disk in v)
					if(w.buttonMode) {					
						w.buttonMode = false;
						w.removeEventListener(MouseEvent.CLICK, w.onClick);
					}
			
					
			
//			trace(Main.ePoint);
			if (Main.ePoint.x > 0) {
				Main.diskList[Main.ePoint.x - 1][Main.ePoint.y].buttonMode = true;
				Main.diskList[Main.ePoint.x - 1][Main.ePoint.y].addEventListener(MouseEvent.CLICK, Main.diskList[Main.ePoint.x - 1][Main.ePoint.y].onClick);
			}
			if (Main.ePoint.y > 0) {
				Main.diskList[Main.ePoint.x][Main.ePoint.y - 1].buttonMode = true;
				Main.diskList[Main.ePoint.x][Main.ePoint.y - 1].addEventListener(MouseEvent.CLICK, Main.diskList[Main.ePoint.x][Main.ePoint.y - 1].onClick);
			}
			if (Main.ePoint.x < N - 1) {
				Main.diskList[Main.ePoint.x + 1][Main.ePoint.y].buttonMode = true;
				Main.diskList[Main.ePoint.x + 1][Main.ePoint.y].addEventListener(MouseEvent.CLICK, Main.diskList[Main.ePoint.x + 1][Main.ePoint.y].onClick);
			}
			if (Main.ePoint.y < N - 1) {				
				Main.diskList[Main.ePoint.x][Main.ePoint.y + 1].buttonMode = true;
				Main.diskList[Main.ePoint.x][Main.ePoint.y + 1].addEventListener(MouseEvent.CLICK, Main.diskList[Main.ePoint.x][Main.ePoint.y + 1].onClick);
			}
			
		}
		
		private function operation(direction:String):void {

			if(direction == "u"){
				SlidingBlock.cur.block[ePoint.x][ePoint.y] = SlidingBlock.cur.block[ePoint.x-1][ePoint.y];   /*状態遷移を実行*/
				SlidingBlock.cur.block[--ePoint.x][ePoint.y] = 0;
			}

			else if(direction == "d"){
				SlidingBlock.cur.block[ePoint.x][ePoint.y] = SlidingBlock.cur.block[ePoint.x+1][ePoint.y];
				SlidingBlock.cur.block[++ePoint.x][ePoint.y] = 0;
			}

			else if(direction == "r"){
				SlidingBlock.cur.block[ePoint.x][ePoint.y] = SlidingBlock.cur.block[ePoint.x][ePoint.y+1];
				SlidingBlock.cur.block[ePoint.x][++ePoint.y] = 0;
			}

			else if(direction == "l"){
				SlidingBlock.cur.block[ePoint.x][ePoint.y] = SlidingBlock.cur.block[ePoint.x][ePoint.y-1];
				SlidingBlock.cur.block[ePoint.x][--ePoint.y] = 0;
			}
			
		}
		
		
		private function onChange(event:Event):void {
			var cb:ComboBox = event.target as ComboBox;
			Node.D = N = cb.selectedItem.data;
			
			for each(var v:Array in Main.diskList)
				for each(var w:Disk in v)
					removeChild(w);
			
			initDisk();
		}
		
		private function setControls():void {
			var cb:ComboBox = new ComboBox();
			cb.move(20, 20);
			cb.prompt = "N =";
			
			for (var i:uint = 2; i < 8 + 1; i++ )
				cb.addItem({label:i.toString(), data:i});
			cb.setSize(50, 20);
			cb.addEventListener(Event.CHANGE, onChange);
			addChild(cb);
						
			var btn:Button = new Button();
			btn.move(90, 20);
			btn.label = "shuffle";
			btn.setSize(60, 20);
			btn.addEventListener(MouseEvent.CLICK, onSet);
			addChild(btn);
			
			btn2 = new Button();
			btn2.move(160, 20);
			btn2.label = "solve";
			btn2.setSize(60, 20);
			btn2.addEventListener(MouseEvent.CLICK, onSolve);
			addChild(btn2);
			
		}
	}	
}
