﻿package  
{
	import Box2D.Dynamics.b2BodyDef;
	
	/**
	 * ...
	 * @author ...
	 */
	public class Node
	{
		static internal var D:uint;
		
		internal var block:Array;        /*各ノードのブロック状態 D×D*/
		internal var ei:int;                /*空白の場所*/
		internal var ej:int;
		internal var nextnum:int;        /*直属の子ノードの数*/
		internal var depth:int;                 /*このノードの深さ*/
		internal var exp:int;                   /*ヒューリスティック値 ＋ 深さ*/
		internal var h:int = 0;
		internal var next:Array;          /*子ノードへのポインタ*/
		internal var reverse:Node;        /*親ノードへのポインタ*/
		internal var nextleaf:Node;       /*リーフだった場合、次のリーフへのポインタ*/
		internal var reverseleaf:Node;    /*前のリーフへのポインタ*/
		
		internal var operation:String;
		
		
		public function Node() 
		{			
			block = new Array();			
			for (var i:uint = 0; i < Main.N; i++ ) {
				var tmp:Array = new Array();
				for (var j:uint = 0; j < Main.N; j++ )
					tmp.push(-1);
				block.push(tmp);
			}
			
		}
		
		internal function heuristic(goal:Node):void {
			var d:int = Main.N * Main.N;
			var i:int;
			var j:int = 0;
			var gi:int;
			var gj:int = 0;
			var b:int;
			var bj:int;

			var f:Boolean;

			for(var k:int = 1; k < d; k++) {
				f = true;

				for(i = 0; i < D && f; i++)
					for(j = 0; j < D && f; j++)
						if(this.block[i][j] == k) {
							f = false;
							i--;                    /*オペレータの制限を緩めてゴールまでの手数を見積もる*/
							j--;
						}

				f = true;

				for(gi = 0; gi < D && f; gi++)
					for(gj = 0; gj < D && f; gj++)
						if(goal.block[gi][gj] == k) {
							f = false;
							gi--;
							gj--;
						}

				this.h += Math.abs((int)(i - gi)) + Math.abs((int)(j - gj));
			}
			this.exp = this.h + this.depth;
		}
		
		
		internal function operate(direction:String):int {
			
			switch(direction) {
				case "d":
					operation = "u";
					break;
				case "u":
					operation = "d";
					break;
				case "l":
					operation = "r";
					break;
				case "r":
					operation = "l";
					break;				
			}
			
			for(var i:int = 0; i < D; i++)
				for(var j:int = 0; j < D; j++)
					this.block[i][j] = this.reverse.block[i][j];

			this.ei = this.reverse.ei;
			this.ej = this.reverse.ej;

			if(direction == "u"){
				this.block[this.ei][this.ej] = this.block[this.ei-1][this.ej];   /*状態遷移を実行*/
				this.block[--this.ei][this.ej] = 0;
			}

			else if(direction == "d"){
				this.block[this.ei][this.ej] = this.block[this.ei+1][this.ej];
				this.block[++this.ei][this.ej] = 0;
			}

			else if(direction == "r"){
				this.block[this.ei][this.ej] = this.block[this.ei][this.ej+1];
				this.block[this.ei][++this.ej] = 0;
			}

			else if(direction == "l"){
				this.block[this.ei][this.ej] = this.block[this.ei][this.ej-1];
				this.block[this.ei][--this.ej] = 0;
			}

			return (this.depth = this.reverse.depth + 1);
		}


		internal function allocate(endleaf:Node):int {

			var k:int = 0;
			var i:int;
			var depth:int = 0;
			var buf:int;
			
			var direction:Array = new Array();

			if(this.ei != 0 && this.reverse.ei+1 != this.ei) {   /*遷移できる状態とその数を調べる*/
				direction.push("u");
				k ++;
			}

			if(this.ei != D-1 && this.reverse.ei != this.ei+1) {
				direction.push("d");
				k ++;
			}

			if (this.ej != 0 && this.reverse.ej + 1 != this.ej) {
				direction.push("l");
				k ++;				
			}

			if (this.ej != D - 1 && this.reverse.ej != this.ej + 1) {
				direction.push("r");
				k ++;				
			}

			this.next = new Array();
			this.nextnum = k;

			for(i = 0; i < k; i++) {
				this.next.push(new Node());

				this.next[i].reverse = this;

				this.next[i].reverseleaf = endleaf.reverseleaf;   /*リストにつなげる*/
				endleaf.reverseleaf.nextleaf = this.next[i];
				this.next[i].nextleaf = endleaf;
				endleaf.reverseleaf = this.next[i];

				if(depth < (buf = this.next[i].operate(direction[i])))
					depth = buf;
			}

			this.reverseleaf.nextleaf = this.nextleaf;
			this.nextleaf.reverseleaf = this.reverseleaf;

			return depth;
		}
		


		internal function allocate2(endleaf:Node, start:Boolean):int {
			
			var k:int = 0;
			var i:int;			
			var depth:int = 0;
			var buf:int;
			 
			var direction:Array = new Array();

			if(this.ei != 0) {   /*遷移できる状態とその数を調べる*/
				direction.push("u");
				k ++;
			}

			if(this.ei != D-1) {
				direction.push("d");
				k ++;
			}
			
			if (this.ej != 0) {
				direction.push("l");
				k ++;
			}

			if (this.ej != D - 1) {
				direction.push("r");
				k ++;				
			}

			this.next = new Array(); 
			this.nextnum = k;

			for(i = 0; i < k; i++) {
				this.next.push(new Node());

				this.next[i].reverse = this;

				this.next[i].reverseleaf = endleaf.reverseleaf;   /*リストにつなげる*/
				endleaf.reverseleaf.nextleaf = this.next[i];
				this.next[i].nextleaf = endleaf;
				endleaf.reverseleaf = this.next[i];

				if(depth < (buf = this.next[i].operate(direction[i])))
					depth = buf;
			}

			this.reverseleaf.nextleaf = this.nextleaf;
			this.nextleaf.reverseleaf = this.reverseleaf;

			return depth;
		}

	}
}






