﻿package  
{
	
	/**
	 * ...
	 * @author ...
	 */
	public class SlidingBlock 
	{

		private var root:Node = new Node();
		private var goal:Node = new Node();
		private var startleaf:Node = new Node();
		private var endleaf:Node = new Node();
		static internal var cur:Node;
		private var next:Node;
		private var depth:int = 0;
		private var buf:int;
		
		public function SlidingBlock() 
		{

			startleaf.nextleaf = root;
			root.nextleaf = endleaf;
			endleaf.reverseleaf = root;
			root.reverseleaf = startleaf;
			endleaf.nextleaf = null;

			init(root, goal);

			root.heuristic(goal);
			if (root.h == 0)
				return;

			if(depth < (buf = root.allocate2(endleaf, true)))
				depth = buf;
				
			for(var i:int = 0; i < root.nextnum; i++)
				root.next[i].heuristic(goal);
				

			while ((next = search(startleaf)).h != 0) {
				if(depth < (buf = next.allocate(endleaf)))
					depth = buf;

				for(i = 0; i < next.nextnum; i++)
					next.next[i].heuristic(goal);
			}
			
			start(next);
		}				
		
		internal function init(root:Node, goal:Node):void {

			var i:int;
			var j:int = Node.D * Node.D;
			var k:int = 1;

			for(i = 0; i < Node.D; i++) {
				for(j = 0; j < Node.D; j++) {
					root.block[i][j] = Main.diskList[i][j].num;
					goal.block[i][j] = k++;
					if(root.block[i][j] == 0){
						root.ei = i;
						root.ej = j;
					}
				}
			}
			

			root.depth = 0;
			root.reverse = null;
			goal.block[Node.D-1][Node.D-1] = 0;
		}		

		internal function search(leaf:Node):Node {
			var nextdev:Node = null;
			var min:int = 50000;

			leaf = leaf.nextleaf;

			while(leaf.nextleaf != null){        /*リーフリストをたどってexpが最小のリーフを探す*/
				if(min > leaf.exp){
					nextdev = leaf;
					min = leaf.exp;
				}
				leaf = leaf.nextleaf;
			}

			return  nextdev;
		}
				

		static private function start(cur:Node):void {

			Disk.tweenDelay = 0;
			
			var i:int;
			var j:int;
			var k:int = 0;

			do{
				cur.reverse.nextleaf = cur;
				cur = cur.reverse;
			}while(cur.reverse != null);    /*ポインタ再利用*/

/*
			do {
				Disk.operate(cur.operation, true, 0.05);
				cur = cur.nextleaf;
			}while(cur.h != 0);
*/

			onComplete(cur.nextleaf);

//			Disk.operate(cur.operation, true, 0.1);
		}
		
		static internal function onComplete(cur:Node):void {			
			nextTween(cur.operation, cur.h == 0, cur);
//			trace(cur.operation);
		}
		
		static private function nextTween(direction:String, end:Boolean, cur:Node):void {
			
			
			
			if (direction == "u")
				Main.diskList[Main.ePoint.x + 1][Main.ePoint.y].cascade(direction, cur, end);
			else if(direction == "d")
				Main.diskList[Main.ePoint.x - 1][Main.ePoint.y].cascade(direction, cur, end);
			else if(direction == "l")
				Main.diskList[Main.ePoint.x][Main.ePoint.y + 1].cascade(direction, cur, end);
			else if(direction == "r")
				Main.diskList[Main.ePoint.x][Main.ePoint.y - 1].cascade(direction, cur, end);
			
			Main.setDiskRandom(0);
		}
				
	}	
}
